package com.gic.haoban.manage.service.dao.mapper.content;

import com.gic.haoban.manage.service.entity.content.TabHaobanPotentialCustomer;
import com.gic.haoban.manage.service.pojo.qo.content.PotentialCustomerQO;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 销售线索(TabHaobanPotentialCustomer)表数据库访问层
 *
 * @author makejava
 * @since 2023-03-28 09:48:07
 */
public interface TabHaobanPotentialCustomerMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    TabHaobanPotentialCustomer queryById(@Param("id") Long id, @Param("clerkId") String clerkId);

    /**
     * 查询销售线索
     * @param clerkId
     * @param memberId
     * @return
     */
    TabHaobanPotentialCustomer queryWithClerkIdAndMemberId(@Param("clerkId") String clerkId, @Param("memberId") String memberId);

    /**
     * 统计总行数
     *
     * @param tabHaobanPotentialCustomer 查询条件
     * @return 总行数
     */
    long count(TabHaobanPotentialCustomer tabHaobanPotentialCustomer);

    /**
     * 新增数据
     *
     * @param tabHaobanPotentialCustomer 实例对象
     * @return 影响行数
     */
    int insert(TabHaobanPotentialCustomer tabHaobanPotentialCustomer);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<TabHaobanPotentialCustomer> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<TabHaobanPotentialCustomer> entities);

    /**
     * 修改数据
     *
     * @param tabHaobanPotentialCustomer 实例对象
     * @return 影响行数
     */
    int update(TabHaobanPotentialCustomer tabHaobanPotentialCustomer);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Long id);

    /**
     * 查询明细
     * @param potentialCustomerQO
     * @return
     */
    List<TabHaobanPotentialCustomer> queryPotentialCustomerList(PotentialCustomerQO potentialCustomerQO);

    /**
     * 会员合并操作
     * @param mergeMemberId
     * @param memberId
     */
    void mergeMember(@Param("mergeMemberId") String mergeMemberId, @Param("memberId") String memberId);

    /**
     * 更新会员成交标识
     * @param enterpriseId
     * @param memberId
     * @return
     */
    int updateMemberDealRecordNum(@Param("enterpriseId") String enterpriseId, @Param("memberId") String memberId);

}

